<script setup lang="ts">
import { computed, onMounted, ref } from 'vue'
import type { StockDetail } from '@/types/StockDetail'
import { useMaterialStore } from '@/stores/material'
import type { Material } from '@/types/Material'

const materialStore = useMaterialStore()
onMounted(() => {
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()
})
const materialheaders = [
  {
    title: 'Material ID',
    key: 'id',
    value: 'id',
    width: '100px'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name',
    width: '300px'
  },
  {
    title: 'Amount',
    key: 'amount',
    value: 'amount',
    width: '300px'
  },
  {
    title: 'Minimum',
    key: 'minimum',
    value: 'minimum',
    width: '300px'
  },
  {
    title: 'Type',
    key: 'type',
    value: 'type',
    width: '300px'
  },
  {
    title: 'The Latest Amount',
    key: 'check',
    value: 'check',
    width: '300px'
  }
]
function amount(item: Material): number {
  const dbMaterials = materialStore.dbmaterials
  const Mat = dbMaterials.find((mat) => mat.id === item.id)
  if (Mat) {
    return Mat.amount
  } else {
    return 0
  }
}
</script>

<template>
  <v-card variant="outlined" color="primary">
    <v-toolbar class="custom-stock-toolbar">
      <v-toolbar-title style="font-size: 24px"> Stock Detail </v-toolbar-title>
      <v-spacer></v-spacer>
    </v-toolbar>
    <v-data-table :items="materialStore.materials" :headers="materialheaders" class="elevation-1 custom-table"
      fixed-header height="350px">
      <template v-slot:item="props">
        <tr>
          <td>{{ props.item.id }}</td>
          <td>{{ props.item.name }}</td>
          <td>{{ amount(props.item) }}</td>
          <td>{{ props.item.minimum }}</td>
          <td>{{ props.item.type }}</td>
          <td>
            <v-text-field v-model="props.item.amount" :readonly="materialStore.loading"
              :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="new QOH" variant="outlined"
              filled rounded density="compact">
            </v-text-field>
            <!-- need import data to editdialog for being to stock detail -->
          </td>
        </tr>
      </template>
    </v-data-table>
  </v-card>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
